<?php
//License: MIT
//Author: de77.com
//Version: 0.2

function imagepbm($im, $fname)
{
	list($wid, $hei) = array(imagesx($im), imagesy($im));
	
	if (!imageistruecolor($im))
	{
		$im2 = imagecreatetruecolor($wid, $hei);
		imagecopy($im2, $im, 0, 0, 0, 0, $wid, $hei);
		imagedestroy($im);
		$im = $im2;
	}
	
	imagefilter($im, IMG_FILTER_GRAYSCALE);

	$str = "P1\n{$wid} {$hei}\n";
	for ($y=0; $y<$hei; $y++)
	{
		for ($x=0; $x<$wid; $x++)
		{
			$rgb = imagecolorat($im, $x, $y);
			$g = $rgb & 0xFF;
			$g = $g>127 ? '1' : '0';

			$str .= $g . ' ';	
		}
	}
	file_put_contents($fname, $str);
}

function imagepgm($im, $fname)
{
	list($wid, $hei) = array(imagesx($im), imagesy($im));

	if (!imageistruecolor($im))
	{
		$im2 = imagecreatetruecolor($wid, $hei);
		imagecopy($im2, $im, 0, 0, 0, 0, $wid, $hei);
		imagedestroy($im);
		$im = $im2;
	}

	imagefilter($im, IMG_FILTER_GRAYSCALE);

	$str = "P5\n{$wid} {$hei}\n255\n";
	for ($y=0; $y<$hei; $y++)
	{
		for ($x=0; $x<$wid; $x++)
		{
			$rgb = imagecolorat($im, $x, $y);
			$g = $rgb & 0xFF;

			$str .= chr($g);	
		}
	}
	file_put_contents($fname, $str);
}

function imagepnm($im, $fname)
{
	list($wid, $hei) = array(imagesx($im), imagesy($im));
	
	if (!imageistruecolor($im))
	{
		$im2 = imagecreatetruecolor($wid, $hei);
		imagecopy($im2, $im, 0, 0, 0, 0, $wid, $hei);
		imagedestroy($im);
		$im = $im2;
	}	
	
	$str = "P6\n{$wid} {$hei}\n255\n";
	for ($y=0; $y<$hei; $y++)
	{
		for ($x=0; $x<$wid; $x++)
		{
			$rgb = imagecolorat($im, $x, $y);
			$r = ($rgb >> 16) & 0xFF;
			$g = ($rgb >> 8) & 0xFF;
			$b = $rgb & 0xFF;
	
			$str .= chr($r) . chr($g) . chr($b);
		}
	}
	file_put_contents($fname, $str);
}
